aboutsummaryrefslogtreecommitdiff
path: root/gdb/contrib
diff options
context:
space:
mode:
authorLancelot SIX <lsix@lancelotsix.com>2021-03-24 23:55:25 +0000
committerLancelot SIX <lsix@lancelotsix.com>2021-05-10 23:14:41 +0100
commitdb1f6cd692cac4818e16f9e3b43ee7802b079d1c (patch)
tree7e133a4f0cf754f52b11c23fd25e2c8d5d777a7e /gdb/contrib
parentb397aef4cd054724fef9fec381f6ca97b52c884e (diff)
downloadbinutils-db1f6cd692cac4818e16f9e3b43ee7802b079d1c.zip
binutils-db1f6cd692cac4818e16f9e3b43ee7802b079d1c.tar.gz
binutils-db1f6cd692cac4818e16f9e3b43ee7802b079d1c.tar.bz2
[PR gdb/27614] gdb-add-index fails on symlinks.
PR 27614 shows that gdb-add-index fails to generate the index when its argument is a symlink. The following one liner illustrates the reported problem: $ echo 'int main(){}'|gcc -g -x c -;ln -s a.out symlink;gdb-add-index symlink gdb-add-index: No index was created for symlink gdb-add-index: [Was there no debuginfo? Was there already an index?] $ ls -l -rwxr-xr-x 1 25712 Mar 19 23:05 a.out* -rw------- 1 8277 Mar 19 23:05 a.out.gdb-index lrwxrwxrwx 1 5 Mar 19 23:05 symlink -> a.out* GDB generates the .gdb-index file with a name that matches the name of the actual program (a.out.gdb-index here), not the symlink that references it. The remaining of the script is looking for a file named after the provided argument (would be 'symlink.gdb-index' in our example). gdb/ChangeLog: PR gdb/27614 * contrib/gdb-add-index.sh: Fix when called with a symlink as an argument. gdb/testsuite/ChangeLog: PR gdb/27614 * gdb.dwarf2/gdb-add-index-symlink.exp: New test.
Diffstat (limited to 'gdb/contrib')
-rwxr-xr-xgdb/contrib/gdb-add-index.sh28
1 files changed, 28 insertions, 0 deletions
diff --git a/gdb/contrib/gdb-add-index.sh b/gdb/contrib/gdb-add-index.sh
index 2ac3fdd..734110c 100755
--- a/gdb/contrib/gdb-add-index.sh
+++ b/gdb/contrib/gdb-add-index.sh
@@ -37,6 +37,34 @@ fi
file="$1"
+if test -L "$file"; then
+ if ! command -v readlink >/dev/null 2>&1; then
+ echo "$myname: 'readlink' missing. Failed to follow symlink $1." 1>&2
+ exit 1
+ fi
+
+ # Count number of links followed in order to detect loops.
+ count=0
+ while test -L "$file"; do
+ target=$(readlink "$file")
+
+ case "$target" in
+ /*)
+ file="$target"
+ ;;
+ *)
+ file="$(dirname "$file")/$target"
+ ;;
+ esac
+
+ count="$((count + 1))"
+ if test "$count" -gt 10; then
+ echo "$myname: Detected loop while following link $file"
+ exit 1
+ fi
+ done
+fi
+
if test ! -r "$file"; then
echo "$myname: unable to access: $file" 1>&2
exit 1